=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2009-04-27 18:41:26 +0000
+++ drizzled/Makefile.am	2009-04-28 00:17:10 +0000
@@ -342,7 +342,6 @@
 		utf8/core.h \
 		utf8/unchecked.h \
 		user_var_entry.h \
-		virtual_column_info.h \
 		xid.h
 
 noinst_LTLIBRARIES = \
@@ -618,7 +617,6 @@
 		tztime.cc \
 		uniques.cc \
 		util/convert.cc \
-		virtual_column_info.cc \
 		xid.cc
 
 if BUILD_DTRACE

=== modified file 'drizzled/field.cc'
--- drizzled/field.cc	2009-04-12 18:37:16 +0000
+++ drizzled/field.cc	2009-04-28 00:17:10 +0000
@@ -28,7 +28,6 @@
 #include "sql_select.h"
 #include <errno.h>
 #include <drizzled/error.h>
-#include <drizzled/virtual_column_info.h>
 #include <drizzled/field/str.h>
 #include <drizzled/field/longstr.h>
 #include <drizzled/field/num.h>
@@ -881,7 +880,7 @@
    part_of_sortkey(0), unireg_check(unireg_check_arg),
    field_length(length_arg), null_bit(null_bit_arg),
    is_created_from_null_item(false),
-   vcol_info(NULL), is_stored(true)
+   is_stored(true)
 {
   flags=null_ptr ? 0: NOT_NULL_FLAG;
   comment.str= (char*) "";
@@ -1375,7 +1374,6 @@
               ((decimals_arg & FIELDFLAG_MAX_DEC) << FIELDFLAG_DEC_SHIFT) |
               (maybe_null ? FIELDFLAG_MAYBE_NULL : 0) |
               (is_unsigned ? 0 : FIELDFLAG_DECIMAL));
-  vcol_info= NULL;
   is_stored= true;
 }
 
@@ -1409,8 +1407,8 @@
                         Item *fld_on_update_value, LEX_STRING *fld_comment,
                         char *fld_change, List<String> *fld_interval_list,
                         const CHARSET_INFO * const fld_charset,
-                        uint32_t, enum column_format_type column_format_in,
-                        virtual_column_info *fld_vcol_info)
+                        uint32_t, enum column_format_type column_format_in)
+                        
 {
   uint32_t sign_len, allowed_type_modifier= 0;
   uint32_t max_field_charlength= MAX_FIELD_CHARLENGTH;
@@ -1439,54 +1437,8 @@
   interval_list.empty();
 
   comment= *fld_comment;
-  vcol_info= fld_vcol_info;
   is_stored= true;
 
-  /* Initialize data for a virtual field */
-  if (fld_type == DRIZZLE_TYPE_VIRTUAL)
-  {
-    assert(vcol_info && vcol_info->expr_item);
-    is_stored= vcol_info->get_field_stored();
-    /*
-      Perform per item-type checks to determine if the expression is
-      allowed for a virtual column.
-      Note that validation of the specific function is done later in
-      procedures open_table_from_share and fix_fields_vcol_func
-    */
-    switch (vcol_info->expr_item->type()) {
-    case Item::FUNC_ITEM:
-         if (((Item_func *)vcol_info->expr_item)->functype() == Item_func::FUNC_SP)
-         {
-           my_error(ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED, MYF(0), field_name);
-           return(true);
-         }
-         break;
-    case Item::COPY_STR_ITEM:
-    case Item::FIELD_AVG_ITEM:
-    case Item::PROC_ITEM:
-    case Item::REF_ITEM:
-    case Item::FIELD_STD_ITEM:
-    case Item::FIELD_VARIANCE_ITEM:
-    case Item::INSERT_VALUE_ITEM:
-    case Item::SUBSELECT_ITEM:
-    case Item::CACHE_ITEM:
-    case Item::TYPE_HOLDER:
-    case Item::PARAM_ITEM:
-         my_error(ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED, MYF(0), field_name);
-         return true;
-    default:
-      // Continue with the field creation
-      break;
-    }
-    /*
-      Make a field created for the real type.
-      Note that "real" and virtual fields differ from each other
-      only by Field::vcol_info, which is always 0 for normal columns.
-      vcol_info is updated for fields later in procedure open_binary_frm.
-    */
-    sql_type= fld_type= vcol_info->get_real_type();
-  }
-
   /*
     Set NO_DEFAULT_VALUE_FLAG if this field doesn't have a default value and
     it is NOT NULL, not an AUTO_INCREMENT field and not a TIMESTAMP.
@@ -1849,7 +1801,6 @@
   charset=    old_field->charset();		// May be NULL ptr
   comment=    old_field->comment;
   decimals=   old_field->decimals();
-  vcol_info=  old_field->vcol_info;
   is_stored= old_field->is_stored;
 
   /* Fix if the original table had 4 byte pointer blobs */

=== modified file 'drizzled/field.h'
--- drizzled/field.h	2009-02-25 16:45:57 +0000
+++ drizzled/field.h	2009-04-28 00:17:10 +0000
@@ -111,8 +111,6 @@
    */
   bool is_created_from_null_item;
 
-  /* Virtual column data */
-  virtual_column_info *vcol_info;
   /*
     Indication that the field is physically stored in tables
     rather than just generated on SQL queries.
@@ -590,8 +588,6 @@
   uint8_t       interval_id;	// For rea_create_table
   uint32_t	offset,pack_flag;
 
-  /* Virtual column expression statement */
-  virtual_column_info *vcol_info;
   /*
     Indication that the field is phycically stored in tables
     rather than just generated on SQL queries.
@@ -622,8 +618,7 @@
             Item *on_update_value, LEX_STRING *comment, char *change,
             List<String> *interval_list, const CHARSET_INFO * const cs,
             uint32_t uint_geom_type,
-            enum column_format_type column_format,
-            virtual_column_info *vcol_info);
+            enum column_format_type column_format);
 };
 
 

=== modified file 'drizzled/filesort.cc'
--- drizzled/filesort.cc	2009-04-08 20:42:29 +0000
+++ drizzled/filesort.cc	2009-04-28 00:17:10 +0000
@@ -524,8 +524,6 @@
       else
       {
 	error=file->rnd_next(sort_form->record[0]);
-        if (!error)
-          update_virtual_fields_marked_for_write(sort_form);
 
 	if (!flag)
 	{

=== modified file 'drizzled/foreign_key.cc'
--- drizzled/foreign_key.cc	2009-03-19 23:04:21 +0000
+++ drizzled/foreign_key.cc	2009-04-28 00:17:10 +0000
@@ -124,27 +124,6 @@
       my_error(ER_KEY_COLUMN_DOES_NOT_EXITS, MYF(0), column->field_name.str);
       return true;
     }
-    if (type == Key::FOREIGN_KEY && sql_field->vcol_info)
-    {
-      if (delete_opt == FK_OPTION_SET_NULL)
-      {
-        my_error(ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN, MYF(0),
-                 "ON DELETE SET NULL");
-        return true;
-      }
-      if (update_opt == FK_OPTION_SET_NULL)
-      {
-        my_error(ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN, MYF(0),
-                 "ON UPDATE SET NULL");
-        return true;
-      }
-      if (update_opt == FK_OPTION_CASCADE)
-      {
-        my_error(ER_WRONG_FK_OPTION_FOR_VIRTUAL_COLUMN, MYF(0),
-                 "ON UPDATE CASCADE");
-        return true;
-      }
-    }
   }
   return false;
 }

=== modified file 'drizzled/function/set_user_var.cc'
--- drizzled/function/set_user_var.cc	2009-04-17 01:45:33 +0000
+++ drizzled/function/set_user_var.cc	2009-04-28 00:17:10 +0000
@@ -22,7 +22,6 @@
 #include <drizzled/function/set_user_var.h>
 #include <drizzled/function/update_hash.h>
 #include <drizzled/field/num.h>
-#include <drizzled/virtual_column_info.h>
 #include <drizzled/session.h>
 
 #include <bitset>
@@ -94,9 +93,6 @@
     Table *table= (Table *) arg;
     if (result_field->table == table || !table)
       result_field->table->read_set->set(result_field->field_index);
-    if (result_field->vcol_info && result_field->vcol_info->expr_item)
-      return result_field->vcol_info->
-               expr_item->walk(&Item::register_field_in_read_map, 1, arg);
   }
   return 0;
 }

=== modified file 'drizzled/item.cc'
--- drizzled/item.cc	2009-04-07 20:25:40 +0000
+++ drizzled/item.cc	2009-04-28 00:17:10 +0000
@@ -28,7 +28,6 @@
 #include <drizzled/item/sum.h>
 #include <drizzled/item/copy_string.h>
 #include <drizzled/function/str/conv_charset.h>
-#include <drizzled/virtual_column_info.h>
 #include <drizzled/sql_base.h>
 #include <drizzled/util/convert.h>
 

=== modified file 'drizzled/item/field.cc'
--- drizzled/item/field.cc	2009-04-12 18:37:16 +0000
+++ drizzled/item/field.cc	2009-04-28 00:17:10 +0000
@@ -22,7 +22,6 @@
 #include <drizzled/session.h>
 #include <drizzled/table.h>
 #include <drizzled/error.h>
-#include <drizzled/virtual_column_info.h>
 #include <drizzled/sql_base.h>
 #include <drizzled/sql_select.h>
 #include <drizzled/item/cmpfunc.h>
@@ -111,9 +110,6 @@
   Table *table= (Table *) arg;
   if (field->table == table || !table)
     field->table->read_set->set(field->field_index);
-  if (field->vcol_info && field->vcol_info->expr_item)
-    return field->vcol_info->expr_item->walk(&Item::register_field_in_read_map,
-                                             1, arg);
   return 0;
 }
 

=== modified file 'drizzled/records.cc'
--- drizzled/records.cc	2009-02-02 18:19:36 +0000
+++ drizzled/records.cc	2009-04-28 00:17:10 +0000
@@ -302,7 +302,7 @@
       break;
     }
   }
-  update_virtual_fields_marked_for_write(info->table);
+
   return tmp;
 }
 
@@ -376,8 +376,7 @@
       break;
     }
   }
-  if (!tmp)
-    update_virtual_fields_marked_for_write(info->table);
+
   return tmp;
 }
 

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2009-04-27 14:36:40 +0000
+++ drizzled/show.cc	2009-04-28 00:17:10 +0000
@@ -33,7 +33,6 @@
 #include <drizzled/item/return_int.h>
 #include <drizzled/item/empty_string.h>
 #include <drizzled/item/return_date_time.h>
-#include <drizzled/virtual_column_info.h>
 #include <drizzled/sql_base.h>
 #include <drizzled/db.h>
 #include <drizzled/field/timestamp.h>
@@ -663,25 +662,9 @@
     else
       type.set_charset(system_charset_info);
 
-    if (field->vcol_info)
-    {
-      packet->append(STRING_WITH_LEN("VIRTUAL "));
-    }
-
     field->sql_type(type);
     packet->append(type.ptr(), type.length(), system_charset_info);
 
-    if (field->vcol_info)
-    {
-      packet->append(STRING_WITH_LEN(" AS ("));
-      packet->append(field->vcol_info->expr_str.str,
-                     field->vcol_info->expr_str.length,
-                     system_charset_info);
-      packet->append(STRING_WITH_LEN(")"));
-      if (field->is_stored)
-        packet->append(STRING_WITH_LEN(" STORED"));
-    }
-
     if (field->has_charset())
     {
       if (field->charset() != share->table_charset)
@@ -729,8 +712,7 @@
           packet->append(STRING_WITH_LEN(" DYNAMIC */"));
       }
     }
-    if (!field->vcol_info &&
-        get_field_default_value(session, table->timestamp_field,
+    if (get_field_default_value(session, table->timestamp_field,
                                 field, &def_value, 1))
     {
       packet->append(STRING_WITH_LEN(" DEFAULT "));
@@ -3092,8 +3074,6 @@
         field->unireg_check != Field::TIMESTAMP_DN_FIELD)
       table->field[16]->store(STRING_WITH_LEN("on update CURRENT_TIMESTAMP"),
                               cs);
-    if (field->vcol_info)
-          table->field[16]->store(STRING_WITH_LEN("VIRTUAL"), cs);
     table->field[18]->store(field->comment.str, field->comment.length, cs);
     {
       enum column_format_type column_format= (enum column_format_type)

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2009-04-12 20:55:58 +0000
+++ drizzled/sql_base.cc	2009-04-28 00:17:10 +0000
@@ -16,7 +16,6 @@
 
 /* Basic functions needed by many modules */
 #include <drizzled/server_includes.h>
-#include <drizzled/virtual_column_info.h>
 #include <drizzled/field/timestamp.h>
 #include <drizzled/field/null.h>
 
@@ -3791,23 +3790,6 @@
 
   if (field_ptr && *field_ptr)
   {
-    if ((*field_ptr)->vcol_info)
-    {
-      if (session->mark_used_columns != MARK_COLUMNS_NONE)
-      {
-        Item *vcol_item= (*field_ptr)->vcol_info->expr_item;
-        assert(vcol_item);
-        vcol_item->walk(&Item::register_field_in_read_map, 1, (unsigned char *) 0);
-        /*
-          Set the virtual field for write here if
-          1) this procedure is called for a read-only operation (SELECT), and
-          2) the virtual column is not phycically stored in the table
-        */
-        if ((session->mark_used_columns != MARK_COLUMNS_WRITE) &&
-            (not (*field_ptr)->is_stored))
-          (*field_ptr)->table->write_set->set((*field_ptr)->field_index);
-      }
-    }
     *cached_field_index_ptr= field_ptr - table->field;
     field= *field_ptr;
   }
@@ -5538,17 +5520,6 @@
       {
         /* Mark fields as used to allow storage engine to optimze access */
         field->table->read_set->set(field->field_index);
-        /*
-          Mark virtual fields for write and others that the virtual fields
-          depend on for read.
-        */
-        if (field->vcol_info)
-        {
-          Item *vcol_item= field->vcol_info->expr_item;
-          assert(vcol_item);
-          vcol_item->walk(&Item::register_field_in_read_map, 1, (unsigned char *) 0);
-          field->table->write_set->set(field->field_index);
-        }
         if (table)
         {
           table->covering_keys.intersect(field->part_of_key);
@@ -5763,18 +5734,6 @@
     table= rfield->table;
     if (rfield == table->next_number_field)
       table->auto_increment_field_not_null= true;
-    if (rfield->vcol_info &&
-        value->type() != Item::DEFAULT_VALUE_ITEM &&
-        value->type() != Item::NULL_ITEM &&
-        table->s->table_category != TABLE_CATEGORY_TEMPORARY)
-    {
-      session->abort_on_warning= false;
-      push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
-                          ER_WARNING_NON_DEFAULT_VALUE_FOR_VIRTUAL_COLUMN,
-                          ER(ER_WARNING_NON_DEFAULT_VALUE_FOR_VIRTUAL_COLUMN),
-                          rfield->field_name, table->s->table_name.str);
-      session->abort_on_warning= abort_on_warning_saved;
-    }
     if ((value->save_in_field(rfield, 0) < 0) && !ignore_errors)
     {
       my_message(ER_UNKNOWN_ERROR, ER(ER_UNKNOWN_ERROR), MYF(0));
@@ -5795,14 +5754,7 @@
         values for virtual fields
       */
       if (table != prev_table)
-      {
         prev_table= table;
-        if (table->vfield)
-        {
-          if (update_virtual_fields_marked_for_write(table, false))
-            goto err;
-        }
-      }
     }
   }
   session->abort_on_warning= abort_on_warning_saved;
@@ -5866,18 +5818,6 @@
     table= field->table;
     if (field == table->next_number_field)
       table->auto_increment_field_not_null= true;
-    if (field->vcol_info &&
-        value->type() != Item::DEFAULT_VALUE_ITEM &&
-        value->type() != Item::NULL_ITEM &&
-        table->s->table_category != TABLE_CATEGORY_TEMPORARY)
-    {
-      session->abort_on_warning= false;
-      push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_WARN,
-                          ER_WARNING_NON_DEFAULT_VALUE_FOR_VIRTUAL_COLUMN,
-                          ER(ER_WARNING_NON_DEFAULT_VALUE_FOR_VIRTUAL_COLUMN),
-                          field->field_name, table->s->table_name.str);
-      session->abort_on_warning= abort_on_warning_saved;
-    }
     if (value->save_in_field(field, 0) < 0)
       goto err;
     tbl_list.push_back(table);
@@ -5897,13 +5837,6 @@
       if (table != prev_table)
       {
         prev_table= table;
-        if (table->vfield)
-        {
-          if (update_virtual_fields_marked_for_write(table, false))
-          {
-            goto err;
-          }
-        }
       }
     }
   }

=== modified file 'drizzled/sql_base.h'
--- drizzled/sql_base.h	2009-03-24 17:44:41 +0000
+++ drizzled/sql_base.h	2009-04-28 00:17:10 +0000
@@ -45,8 +45,7 @@
 		       Item *default_value, Item *on_update_value,
 		       LEX_STRING *comment,
 		       char *change, List<String> *interval_list,
-		       const CHARSET_INFO * const cs,
-		       virtual_column_info *vcol_info);
+		       const CHARSET_INFO * const cs);
 Create_field * new_create_field(Session *session, char *field_name, enum_field_types type,
 				char *length, char *decimals,
 				uint32_t type_modifier,

=== modified file 'drizzled/sql_insert.cc'
--- drizzled/sql_insert.cc	2009-04-12 19:59:09 +0000
+++ drizzled/sql_insert.cc	2009-04-28 00:17:10 +0000
@@ -128,9 +128,6 @@
         table->write_set->set(table->timestamp_field->field_index);
       }
     }
-    /* Mark all virtual columns for write*/
-    if (table->vfield)
-      table->mark_virtual_columns();
   }
 
   return 0;

=== modified file 'drizzled/sql_parse.cc'
--- drizzled/sql_parse.cc	2009-04-27 14:36:40 +0000
+++ drizzled/sql_parse.cc	2009-04-28 00:17:10 +0000
@@ -1808,8 +1808,7 @@
 		       Item *default_value, Item *on_update_value,
                        LEX_STRING *comment,
 		       char *change,
-                       List<String> *interval_list, const CHARSET_INFO * const cs,
-                       virtual_column_info *vcol_info)
+                       List<String> *interval_list, const CHARSET_INFO * const cs)
 {
   register Create_field *new_field;
   LEX  *lex= session->lex;
@@ -1880,8 +1879,7 @@
   if (!(new_field= new Create_field()) ||
       new_field->init(session, field_name->str, type, length, decimals, type_modifier,
                       default_value, on_update_value, comment, change,
-                      interval_list, cs, 0, column_format,
-                      vcol_info))
+                      interval_list, cs, 0, column_format))
     return(1);
 
   lex->alter_info.create_list.push_back(new_field);

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2009-04-12 18:37:16 +0000
+++ drizzled/sql_select.cc	2009-04-28 00:17:10 +0000
@@ -11385,7 +11385,6 @@
       empty_record(table);			// Make empty record
       return -1;
     }
-    update_virtual_fields_marked_for_write(table);
     store_record(table,record[1]);
   }
   else if (!table->status)			// Only happens with left join
@@ -11434,7 +11433,6 @@
 	return table->report_error(error);
       return -1;
     }
-    update_virtual_fields_marked_for_write(table);
     store_record(table,record[1]);
   }
   else if (!(table->status & ~STATUS_NULL_ROW))	// Only happens with left join
@@ -11543,7 +11541,7 @@
       return table->report_error(error);
     return -1; /* purecov: inspected */
   }
-  update_virtual_fields_marked_for_write(table);
+
   return 0;
 }
 
@@ -11630,7 +11628,7 @@
     table->status= STATUS_GARBAGE;
     return -1;
   }
-  update_virtual_fields_marked_for_write(table);
+
   return 0;
 }
 
@@ -11650,7 +11648,7 @@
     table->status=STATUS_NOT_FOUND;
     error= -1;
   }
-  update_virtual_fields_marked_for_write(table);
+
   return error;
 }
 
@@ -11731,8 +11729,7 @@
       table->report_error(error);
     return -1;
   }
-  if (not error)
-    update_virtual_fields_marked_for_write(tab->table);
+
   return 0;
 }
 
@@ -11752,8 +11749,6 @@
 
       if ((error=info->file->index_next(info->record)))
         return info->table->report_error(error);
-      if (not error)
-        update_virtual_fields_marked_for_write(tab->table);
     } while (!key_cmp(tab->table->key_info[tab->index].key_part,
                       tab->insideout_buf, key->key_length));
     tab->insideout_match_tab->found_match= 0;
@@ -11770,8 +11765,6 @@
   int error;
   if ((error=info->file->index_next(info->record)))
     return info->table->report_error(error);
-  if (not error)
-    update_virtual_fields_marked_for_write(info->table);
   return 0;
 }
 
@@ -11797,8 +11790,7 @@
     table->file->ha_index_init(tab->index, 1);
   if ((error= tab->table->file->index_last(tab->table->record[0])))
     return table->report_error(error);
-  if (not error)
-    update_virtual_fields_marked_for_write(tab->table);
+
   return 0;
 }
 
@@ -11809,8 +11801,7 @@
   int error;
   if ((error= info->file->index_prev(info->record)))
     return info->table->report_error(error);
-  if (not error)
-    update_virtual_fields_marked_for_write(info->table);
+
   return 0;
 }
 

=== modified file 'drizzled/sql_table.cc'
--- drizzled/sql_table.cc	2009-04-12 07:28:35 +0000
+++ drizzled/sql_table.cc	2009-04-28 00:17:10 +0000
@@ -872,8 +872,7 @@
                           (sql_field->decimals << FIELDFLAG_DEC_SHIFT));
     break;
   }
-  if (!(sql_field->flags & NOT_NULL_FLAG) ||
-      (sql_field->vcol_info)) /* Make virtual columns always allow NULL values */
+  if (!(sql_field->flags & NOT_NULL_FLAG))
     sql_field->pack_flag|= FIELDFLAG_MAYBE_NULL;
   if (sql_field->flags & NO_DEFAULT_VALUE_FLAG)
     sql_field->pack_flag|= FIELDFLAG_NO_DEFAULT;
@@ -1128,7 +1127,6 @@
             null_fields--;
 	  sql_field->flags=		dup_field->flags;
           sql_field->interval=          dup_field->interval;
-          sql_field->vcol_info=         dup_field->vcol_info;
           sql_field->is_stored=      dup_field->is_stored;
 	  it2.remove();			// Remove first (create) definition
 	  select_field_pos--;
@@ -1421,11 +1419,6 @@
           my_error(ER_KEY_BASED_ON_GENERATED_VIRTUAL_COLUMN, MYF(0));
           return(true);
         }
-        if (key->type == Key::PRIMARY && sql_field->vcol_info)
-        {
-          my_error(ER_PRIMARY_KEY_BASED_ON_VIRTUAL_COLUMN, MYF(0));
-          return(true);
-        }
 	if (!(sql_field->flags & NOT_NULL_FLAG))
 	{
 	  if (key->type == Key::PRIMARY)
@@ -3374,14 +3367,6 @@
       if (!(table_changes_local= field->is_equal(new_field)))
         alter_flags->set(HA_ALTER_COLUMN_TYPE);
 
-      /*
-        Check if the altered column is a stored virtual field.
-        TODO: Mark such a column with an alter flag only if
-        the expression functions are not equal.
-      */
-      if (field->is_stored && field->vcol_info)
-        alter_flags->set(HA_ALTER_STORED_VCOL);
-
       /* Check if field was renamed */
       field->flags&= ~FIELD_IS_RENAMED;
       if (my_strcasecmp(system_charset_info,
@@ -5197,7 +5182,6 @@
       copy_ptr->do_copy(copy_ptr);
     }
     prev_insert_id= to->file->next_insert_id;
-    update_virtual_fields_marked_for_write(to, false);
     error=to->file->ha_write_row(to->record[0]);
     to->auto_increment_field_not_null= false;
     if (error)

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2009-04-14 01:01:44 +0000
+++ drizzled/sql_yacc.yy	2009-04-28 00:17:10 +0000
@@ -78,7 +78,6 @@
 #include <drizzled/item/cmpfunc.h>
 #include <drizzled/item/uint.h>
 #include <drizzled/item/null.h>
-#include <drizzled/virtual_column_info.h>
 #include <drizzled/session.h>
 #include <drizzled/item/func.h>
 #include <drizzled/sql_base.h>
@@ -1600,8 +1599,7 @@
                                   lex->column_format,
                                   lex->default_value, lex->on_update_value, 
                                   &lex->comment,
-                                  lex->change,&lex->interval_list,lex->charset,
-                                  lex->vcol_info))
+                                  lex->change,&lex->interval_list,lex->charset))
               DRIZZLE_YYABORT;
           }
         ;
@@ -2210,8 +2208,7 @@
                                   lex->column_format,
                                   lex->default_value, lex->on_update_value,
                                   &lex->comment,
-                                  $3.str, &lex->interval_list, lex->charset,
-                                  lex->vcol_info))
+                                  $3.str, &lex->interval_list, lex->charset))
               DRIZZLE_YYABORT;
           }
           opt_place

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2009-04-13 19:54:54 +0000
+++ drizzled/table.cc	2009-04-28 00:17:10 +0000
@@ -25,7 +25,6 @@
 #include <drizzled/data_home.h>
 #include <drizzled/sql_parse.h>
 #include <drizzled/item/sum.h>
-#include <drizzled/virtual_column_info.h>
 #include <drizzled/table_list.h>
 #include <drizzled/session.h>
 #include <drizzled/sql_base.h>
@@ -1002,30 +1001,11 @@
     }
 
     enum_field_types field_type;
-    virtual_column_info *vcol_info= NULL;
     bool field_is_stored= true;
 
 
     field_type= proto_field_type_to_drizzle_type(pfield.type());
 
-    if(field_type==DRIZZLE_TYPE_VIRTUAL)
-    {
-      drizzled::message::Table::Field::VirtualFieldOptions field_options=
-	pfield.virtual_options();
-
-      vcol_info= new virtual_column_info();
-      field_type= proto_field_type_to_drizzle_type(field_options.type());
-      field_is_stored= field_options.physically_stored();
-
-      size_t len= field_options.expression().length();
-      const char* str= field_options.expression().c_str();
-
-      vcol_info->expr_str.str= strmake_root(&share->mem_root, str, len);
-      vcol_info->expr_str.length= len;
-
-      share->vfields++;
-    }
-
     const CHARSET_INFO *charset= &my_charset_bin;
 
     if(field_type==DRIZZLE_TYPE_BLOB
@@ -1131,7 +1111,6 @@
 
     f->field_index= fieldnr;
     f->comment= comment;
-    f->vcol_info= vcol_info;
     f->is_stored= field_is_stored;
     if(!default_value
        && !(f->unireg_check==Field::NEXT_NUMBER)
@@ -1472,275 +1451,6 @@
   return(error);
 }
 
-/*
-  Clear flag GET_FIXED_FIELDS_FLAG in all fields of the table.
-  This routine is used for error handling purposes.
-
-  SYNOPSIS
-    clear_field_flag()
-    table                Table object for which virtual columns are set-up
-
-  RETURN VALUE
-    NONE
-*/
-static void clear_field_flag(Table *table)
-{
-  Field **ptr;
-
-  for (ptr= table->field; *ptr; ptr++)
-    (*ptr)->flags&= (~GET_FIXED_FIELDS_FLAG);
-}
-
-/*
-  The function uses the feature in fix_fields where the flag
-  GET_FIXED_FIELDS_FLAG is set for all fields in the item tree.
-  This field must always be reset before returning from the function
-  since it is used for other purposes as well.
-
-  SYNOPSIS
-    fix_fields_vcol_func()
-    session                  The thread object
-    func_item            The item tree reference of the virtual columnfunction
-    table                The table object
-    field_name           The name of the processed field
-
-  RETURN VALUE
-    true                 An error occurred, something was wrong with the
-                         function.
-    false                Ok, a partition field array was created
-*/
-
-bool fix_fields_vcol_func(Session *session,
-                          Item* func_expr,
-                          Table *table,
-                          const char *field_name)
-{
-  uint32_t dir_length, home_dir_length;
-  bool result= true;
-  TableList tables;
-  TableList *save_table_list, *save_first_table, *save_last_table;
-  int error;
-  Name_resolution_context *context;
-  const char *save_where;
-  char* db_name;
-  char db_name_string[FN_REFLEN];
-  bool save_use_only_table_context;
-  Field **ptr, *field;
-  enum_mark_columns save_mark_used_columns= session->mark_used_columns;
-  assert(func_expr);
-
-  /*
-    Set-up the TABLE_LIST object to be a list with a single table
-    Set the object to zero to create NULL pointers and set alias
-    and real name to table name and get database name from file name.
-  */
-
-  bzero((void*)&tables, sizeof(TableList));
-  tables.alias= tables.table_name= (char*) table->s->table_name.str;
-  tables.table= table;
-  tables.next_local= NULL;
-  tables.next_name_resolution_table= NULL;
-  memcpy(db_name_string,
-         table->s->normalized_path.str,
-         table->s->normalized_path.length);
-  db_name_string[table->s->normalized_path.length]= '\0';
-  dir_length= dirname_length(db_name_string);
-  db_name_string[dir_length - 1]= 0;
-  home_dir_length= dirname_length(db_name_string);
-  db_name= &db_name_string[home_dir_length];
-  tables.db= db_name;
-
-  session->mark_used_columns= MARK_COLUMNS_NONE;
-
-  context= session->lex->current_context();
-  table->map= 1; //To ensure correct calculation of const item
-  table->get_fields_in_item_tree= true;
-  save_table_list= context->table_list;
-  save_first_table= context->first_name_resolution_table;
-  save_last_table= context->last_name_resolution_table;
-  context->table_list= &tables;
-  context->first_name_resolution_table= &tables;
-  context->last_name_resolution_table= NULL;
-  func_expr->walk(&Item::change_context_processor, 0, (unsigned char*) context);
-  save_where= session->where;
-  session->where= "virtual column function";
-
-  /* Save the context before fixing the fields*/
-  save_use_only_table_context= session->lex->use_only_table_context;
-  session->lex->use_only_table_context= true;
-  /* Fix fields referenced to by the virtual column function */
-  error= func_expr->fix_fields(session, (Item**)0);
-  /* Restore the original context*/
-  session->lex->use_only_table_context= save_use_only_table_context;
-  context->table_list= save_table_list;
-  context->first_name_resolution_table= save_first_table;
-  context->last_name_resolution_table= save_last_table;
-
-  if (unlikely(error))
-  {
-    clear_field_flag(table);
-    goto end;
-  }
-  session->where= save_where;
-  /*
-    Walk through the Item tree checking if all items are valid
-   to be part of the virtual column
- */
-  error= func_expr->walk(&Item::check_vcol_func_processor, 0, NULL);
-  if (error)
-  {
-    my_error(ER_VIRTUAL_COLUMN_FUNCTION_IS_NOT_ALLOWED, MYF(0), field_name);
-    clear_field_flag(table);
-    goto end;
-  }
-  if (unlikely(func_expr->const_item()))
-  {
-    my_error(ER_CONST_EXPR_IN_VCOL, MYF(0));
-    clear_field_flag(table);
-    goto end;
-  }
-  /* Ensure that this virtual column is not based on another virtual field. */
-  ptr= table->field;
-  while ((field= *(ptr++)))
-  {
-    if ((field->flags & GET_FIXED_FIELDS_FLAG) &&
-        (field->vcol_info))
-    {
-      my_error(ER_VCOL_BASED_ON_VCOL, MYF(0));
-      clear_field_flag(table);
-      goto end;
-    }
-  }
-  /*
-    Cleanup the fields marked with flag GET_FIXED_FIELDS_FLAG
-    when calling fix_fields.
-  */
-  clear_field_flag(table);
-  result= false;
-
-end:
-  table->get_fields_in_item_tree= false;
-  session->mark_used_columns= save_mark_used_columns;
-  table->map= 0; //Restore old value
-  return(result);
-}
-
-/*
-  Unpack the definition of a virtual column
-
-  SYNOPSIS
-    unpack_vcol_info_from_frm()
-    session                  Thread handler
-    table                Table with the checked field
-    field                Pointer to Field object
-    open_mode            Open table mode needed to determine
-                         which errors need to be generated in a failure
-    error_reported       updated flag for the caller that no other error
-                         messages are to be generated.
-
-  RETURN VALUES
-    true            Failure
-    false           Success
-*/
-bool unpack_vcol_info_from_frm(Session *session,
-                               Table *table,
-                               Field *field,
-                               LEX_STRING *vcol_expr,
-                               open_table_mode open_mode,
-                               bool *error_reported)
-{
-  assert(vcol_expr);
-
-  /*
-    Step 1: Construct a statement for the parser.
-    The parsed string needs to take the following format:
-    "PARSE_VCOL_EXPR (<expr_string_from_frm>)"
-  */
-  char *vcol_expr_str;
-  int str_len= 0;
-
-  if (!(vcol_expr_str= (char*) alloc_root(&table->mem_root,
-                                          vcol_expr->length +
-                                            parse_vcol_keyword.length + 3)))
-  {
-    return(true);
-  }
-  memcpy(vcol_expr_str,
-         (char*) parse_vcol_keyword.str,
-         parse_vcol_keyword.length);
-  str_len= parse_vcol_keyword.length;
-  memcpy(vcol_expr_str + str_len, "(", 1);
-  str_len++;
-  memcpy(vcol_expr_str + str_len,
-         (char*) vcol_expr->str,
-         vcol_expr->length);
-  str_len+= vcol_expr->length;
-  memcpy(vcol_expr_str + str_len, ")", 1);
-  str_len++;
-  memcpy(vcol_expr_str + str_len, "\0", 1);
-  str_len++;
-  Lex_input_stream lip(session, vcol_expr_str, str_len);
-
-  /*
-    Step 2: Setup session for parsing.
-    1) make Item objects be created in the memory allocated for the Table
-       object (not TABLE_SHARE)
-    2) ensure that created Item's are not put on to session->free_list
-       (which is associated with the parsed statement and hence cleared after
-       the parsing)
-    3) setup a flag in the LEX structure to allow "PARSE_VCOL_EXPR"
-       to be parsed as a SQL command.
-  */
-  MEM_ROOT **root_ptr, *old_root;
-  Item *backup_free_list= session->free_list;
-  root_ptr= current_mem_root_ptr();
-  old_root= *root_ptr;
-  *root_ptr= &table->mem_root;
-  session->free_list= NULL;
-  session->lex->parse_vcol_expr= true;
-
-  /*
-    Step 3: Use the parser to build an Item object from.
-  */
-  if (parse_sql(session, &lip))
-  {
-    goto parse_err;
-  }
-  /* From now on use vcol_info generated by the parser. */
-  field->vcol_info= session->lex->vcol_info;
-
-  /* Validate the Item tree. */
-  if (fix_fields_vcol_func(session,
-                           field->vcol_info->expr_item,
-                           table,
-                           field->field_name))
-  {
-    if (open_mode == OTM_CREATE)
-    {
-      /*
-        During CREATE/ALTER TABLE it is ok to receive errors here.
-        It is not ok if it happens during the opening of an frm
-        file as part of a normal query.
-      */
-      *error_reported= true;
-    }
-    field->vcol_info= NULL;
-    goto parse_err;
-  }
-  field->vcol_info->item_free_list= session->free_list;
-  session->free_list= backup_free_list;
-  *root_ptr= old_root;
-
-  return(false);
-
-parse_err:
-  session->lex->parse_vcol_expr= false;
-  session->free_items();
-  *root_ptr= old_root;
-  session->free_list= backup_free_list;
-  return(true);
-}
-
 
 /*
   Open a table based on a TABLE_SHARE
@@ -1778,7 +1488,7 @@
   uint32_t records, i;
   bool error_reported= false;
   unsigned char *record;
-  Field **field_ptr, **vfield_ptr;
+  Field **field_ptr;
 
   /* Parsing of partitioning information from .frm needs session->lex set up. */
   assert(session->lex->is_lex_started);
@@ -1925,45 +1635,6 @@
     }
   }
 
-  /*
-    Process virtual columns, if any.
-  */
-  if (not (vfield_ptr = (Field **) alloc_root(&outparam->mem_root,
-                                              (uint32_t) ((share->vfields+1)*
-                                                      sizeof(Field*)))))
-    goto err;
-
-  outparam->vfield= vfield_ptr;
-
-  for (field_ptr= outparam->field; *field_ptr; field_ptr++)
-  {
-    if ((*field_ptr)->vcol_info)
-    {
-      if (unpack_vcol_info_from_frm(session,
-                                    outparam,
-                                    *field_ptr,
-                                    &(*field_ptr)->vcol_info->expr_str,
-                                    open_mode,
-                                    &error_reported))
-      {
-        error= 4; // in case no error is reported
-        goto err;
-      }
-      *(vfield_ptr++)= *field_ptr;
-    }
-  }
-  *vfield_ptr= NULL;                              // End marker
-  /* Check virtual columns against table's storage engine. */
-  if ((share->vfields && outparam->file) &&
-        (not outparam->file->check_if_supported_virtual_columns()))
-  {
-    my_error(ER_UNSUPPORTED_ACTION_ON_VIRTUAL_COLUMN,
-             MYF(0),
-             "Specified storage engine");
-    error_reported= true;
-    goto err;
-  }
-
   /* Allocate bitmaps */
   outparam->default_column_bitmaps();
 
@@ -3188,14 +2859,7 @@
   KEY_PART_INFO *key_part_end= (key_part +
                                 key_info[index].key_parts);
   for (;key_part != key_part_end; key_part++)
-  {
     bitmap->set(key_part->fieldnr-1);
-    if (key_part->field->vcol_info &&
-        key_part->field->vcol_info->expr_item)
-      key_part->field->vcol_info->
-               expr_item->walk(&Item::register_field_in_bitmap,
-                               1, (unsigned char *) bitmap);
-  }
 }
 
 
@@ -3319,8 +2983,6 @@
       file->column_bitmaps_signal();
     }
   }
-  /* Mark all virtual columns as writable */
-  mark_virtual_columns();
   return;
 }
 
@@ -3336,40 +2998,6 @@
 {
   if (found_next_number_field)
     mark_auto_increment_column();
-  /* Mark all virtual columns as writable */
-  mark_virtual_columns();
-}
-
-/*
-  @brief Update the write and read table bitmap to allow
-         using procedure save_in_field for all virtual columns
-         in the table.
-
-  @return       void
-
-  @detail
-    Each virtual field is set in the write column map.
-    All fields that the virtual columns are based on are set in the
-    read bitmap.
-*/
-
-void Table::mark_virtual_columns(void)
-{
-  Field **vfield_ptr, *tmp_vfield;
-  bool bitmap_updated= false;
-
-  for (vfield_ptr= vfield; *vfield_ptr; vfield_ptr++)
-  {
-    tmp_vfield= *vfield_ptr;
-    assert(tmp_vfield->vcol_info && tmp_vfield->vcol_info->expr_item);
-    tmp_vfield->vcol_info->expr_item->walk(&Item::register_field_in_read_map,
-                                           1, (unsigned char *) 0);
-    read_set->set(tmp_vfield->field_index);
-    write_set->set(tmp_vfield->field_index);
-    bitmap_updated= true;
-  }
-  if (bitmap_updated)
-    file->column_bitmaps_signal();
 }
 
 
@@ -4937,53 +4565,6 @@
 }
 
 
-/*
-  Calculate data for each virtual field marked for write in the
-  corresponding column map.
-
-  SYNOPSIS
-    update_virtual_fields_marked_for_write()
-    table                  The Table object
-    ignore_stored          Indication whether physically stored virtual
-                           fields do not need updating.
-                           This value is false when during INSERT and UPDATE
-                           and true in all other cases.
-
-  RETURN
-    0  - Success
-    >0 - Error occurred during the generation/calculation of a virtual field value
-
-*/
-
-int update_virtual_fields_marked_for_write(Table *table,
-                                           bool ignore_stored)
-{
-  Field **vfield_ptr, *vfield;
-  int error= 0;
-  if ((not table) or (not table->vfield))
-    return(0);
-
-  /* Iterate over virtual fields in the table */
-  for (vfield_ptr= table->vfield; *vfield_ptr; vfield_ptr++)
-  {
-    vfield= (*vfield_ptr);
-    assert(vfield->vcol_info && vfield->vcol_info->expr_item);
-    /*
-      Only update those fields that are marked in the write_set bitmap
-      and not _already_ physically stored in the database.
-    */
-    if (table->write_set->test(vfield->field_index) &&
-        (not (ignore_stored && vfield->is_stored))
-       )
-    {
-      /* Generate the actual value of the virtual fields */
-      error= vfield->vcol_info->expr_item->save_in_field(vfield, 0);
-    }
-  }
-  return(0);
-}
-
-
 void Table::setup_table_map(TableList *table_list, uint32_t table_number)
 {
   used_fields= 0;

=== modified file 'drizzled/table.h'
--- drizzled/table.h	2009-04-12 20:55:58 +0000
+++ drizzled/table.h	2009-04-28 00:17:10 +0000
@@ -151,7 +151,6 @@
   Field *next_number_field;		/* Set if next_number is activated */
   Field *found_next_number_field;	/* Set on open */
   Field_timestamp *timestamp_field;
-  Field **vfield;                       /* Pointer to virtual fields*/
 
   TableList *pos_in_table_list;/* Element referring to this table */
   order_st *group;
@@ -293,7 +292,6 @@
   void mark_columns_needed_for_update(void);
   void mark_columns_needed_for_delete(void);
   void mark_columns_needed_for_insert(void);
-  void mark_virtual_columns(void);
   inline void column_bitmaps_set(std::bitset<MAX_FIELDS> *read_set_arg,
                                  std::bitset<MAX_FIELDS> *write_set_arg)
   {

=== modified file 'drizzled/table_proto_write.cc'
--- drizzled/table_proto_write.cc	2009-04-10 05:31:39 +0000
+++ drizzled/table_proto_write.cc	2009-04-28 00:17:10 +0000
@@ -15,7 +15,6 @@
 
 #include <drizzled/server_includes.h>
 #include <drizzled/error.h>
-#include <drizzled/virtual_column_info.h>
 #include <drizzled/session.h>
 #include <drizzled/unireg.h>
 
@@ -174,37 +173,6 @@
       assert(0); /* Tell us, since this shouldn't happend */
     }
 
-    if(field_arg->vcol_info)
-    {
-      uint32_t tmp_len;
-      tmp_len= system_charset_info->cset->charpos(system_charset_info,
-					  field_arg->vcol_info->expr_str.str,
-                                          field_arg->vcol_info->expr_str.str +
-                                          field_arg->vcol_info->expr_str.length,
-                                          VIRTUAL_COLUMN_EXPRESSION_MAXLEN);
-
-      if (tmp_len < field_arg->vcol_info->expr_str.length)
-      {
-        my_error(ER_WRONG_STRING_LENGTH, MYF(0),
-                 field_arg->vcol_info->expr_str.str,"VIRTUAL COLUMN EXPRESSION",
-                 (uint32_t) VIRTUAL_COLUMN_EXPRESSION_MAXLEN);
-        return(1);
-      }
-
-      drizzled::message::Table::Field::VirtualFieldOptions *field_options;
-
-      field_options= attribute->mutable_virtual_options();
-
-      field_options->set_type(attribute->type());
-      attribute->set_type(drizzled::message::Table::Field::VIRTUAL);
-
-      string expr(field_arg->vcol_info->expr_str.str,
-		  field_arg->vcol_info->expr_str.length);
-
-      field_options->set_expression(expr);
-      field_options->set_physically_stored(field_arg->is_stored);
-    }
-
 #ifdef NOTDONE
     field_constraints= attribute->mutable_constraints();
     constraints->set_is_nullable(field_arg->def->null_value);

=== removed file 'drizzled/virtual_column_info.cc'
--- drizzled/virtual_column_info.cc	2008-11-17 07:23:53 +0000
+++ drizzled/virtual_column_info.cc	1970-01-01 00:00:00 +0000
@@ -1,49 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#include <drizzled/server_includes.h>
-#include <drizzled/virtual_column_info.h>
-
-enum_field_types virtual_column_info::get_real_type()
-{
-  assert(data_inited);
-  return data_inited ? field_type : DRIZZLE_TYPE_VIRTUAL;
-}
-
-
-void virtual_column_info::set_field_type(enum_field_types fld_type)
-{
-  /* Calling this function can only be done once. */
-  assert(not data_inited);
-  data_inited= true;
-  field_type= fld_type;
-}
-
-
-bool virtual_column_info::get_field_stored()
-{
-  assert(data_inited);
-  return data_inited ? is_stored : true;
-}
-
-
-void virtual_column_info::set_field_stored(bool stored)
-{
-  is_stored= stored;
-}

=== removed file 'drizzled/virtual_column_info.h'
--- drizzled/virtual_column_info.h	2008-11-17 07:23:53 +0000
+++ drizzled/virtual_column_info.h	1970-01-01 00:00:00 +0000
@@ -1,65 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#ifndef DRIZZLED_VIRTUAL_COLUMN_INFO_H
-#define DRIZZLED_VIRTUAL_COLUMN_INFO_H
-
-#include <drizzled/definitions.h>
-#include <drizzled/sql_alloc.h>
-#include <drizzled/lex_string.h>
-
-class Item;
-
-class virtual_column_info: public Sql_alloc
-{
-public:
-  Item *expr_item;
-  LEX_STRING expr_str;
-  Item *item_free_list;
-
-  virtual_column_info()
-  : expr_item(0), item_free_list(0),
-    field_type(DRIZZLE_TYPE_VIRTUAL),
-    is_stored(false), data_inited(false)
-  {
-    expr_str.str= NULL;
-    expr_str.length= 0;
-  };
-  ~virtual_column_info() {}
-  enum_field_types get_real_type();
-  void set_field_type(enum_field_types fld_type);
-  bool get_field_stored();
-  void set_field_stored(bool stored);
-
-private:
-  /*
-    The following data is only updated by the parser and read
-    when a Create_field object is created/initialized.
-  */
-  enum_field_types field_type;   /* Real field type*/
-  bool is_stored;             /* Indication that the field is
-                                 phisically stored in the database*/
-  /*
-    This flag is used to prevent other applications from
-    reading and using incorrect data.
-  */
-  bool data_inited;
-};
-
-#endif /* DRIZZLED_VIRTUAL_COLUMN_INFO_H */

